﻿/***********************************************************************************************************
        Apply Alt Tag to Document Images
        Version : 1.1
        Type : Script
        InDesign : CS5.5
        Idea : Anne-Marie Concepcion | http://indesignsecrets.com
        Author : Marijan Tompa (tomaxxi) | Subotica [Serbia]
        Date : 12/07/2011
        Contact : me (at) tomaxxi (dot) com
        Twitter: @tomaxxi
        Web : http://tomaxxi.com
***********************************************************************************************************/

var appName = "Object ALT Text Changer | by @tomaxxi";

if(parseFloat(app.version) > 7){
    if(app.documents.length < 1){
        alert("No Documents Opened!", appName);
        exit();
    }else{
        var doc = app.activeDocument;
        if(doc.links.length < 1){
            alert("No Links found!", appName);
            exit();
        }
    }
    addAltText();
}else{
    alert("Only Adobe InDesign CS5.5 is supported!", appName);
    exit();
}

function addAltText(){
    var lnk = doc.links;
    var sources = ["From Structure", "XMP : Title", "XMP : Description", "XMP : Headline"];
    var values = [SourceType.SOURCE_XML_STRUCTURE, SourceType.SOURCE_XMP_TITLE, SourceType.SOURCE_XMP_DESCRIPTION, SourceType.SOURCE_XMP_HEADLINE];
    var dlg = new Window('dialog', appName);
    var g0 = dlg.add('group');
    var p0 = g0.add('panel');
        p0.orientation = 'row';
        p0.add('statictext', undefined, "Alt Text Source:");
        var source = p0.add('dropdownlist', undefined, sources);
            source.selection = 2;
    var overwirte = dlg.add('checkbox', undefined, 'Overwrite Existing');
    var g1 = dlg.add('group');
    var ok = g1.add('button', undefined, "OK");
    var canc = g1.add('button', undefined, "Cancel");
    
    var ico = "\x89PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x9E\x00\x00\x00\x1E\b\x03\x00\x00\x00\xEA\xEBW\x91\x00\x00\x00\x03sBIT\b\b\b\xDB\xE1O\xE0\x00\x00\x00\xC0PLTE\x00\x00\x00n\x82\x9D\xB8\xBB\xC4333\xAD\xAD\xAD\x14<x\xDE\xDE\xDEkkk:Fg\x99\x99\x99\x8C\x8C\x8C\xED\xEC\xE8Tn\x93.P\x83DGZ\xBD\xBD\xBD\xD1\xD2\xD2!!!\x84\x84\x84\x88\x95\xA8\xCC\xCC\xCC\xF7\xF7\xF7\xA5\xA5\xA5Gd\x8D{{{^dtax\x98\xAE\xB3\xB8\xE6\xE6\xE6!F}{\x8B\xA3\x13\x13\x13\xD5\xD1\xC8:::RRR\x94\x94\x94sss\x00\x04\x1E\xFF\xFF\xFF\xA2\xA9\xB3Yd}PRc\x95\x9F\xADxz\x86CCC\x00\x00\x19]h~\xB5\xB5\xB5\xC5\xC5\xC5XXX\xF5\xF4\xF1KQl;Z\x886:D\x9F\x9E\xA9***\xD6\xD6\xD6\xEB\xE9\xEBfff\x00\x00\x12\x00\x07*JJJQ]r\xEF\xEF\xEF\xAB\f{ \x00\x00\x00\tpHYs\x00\x00\x0B\x12\x00\x00\x0B\x12\x01\xD2\xDD~\xFC\x00\x00\x00\x1EtEXtSoftware\x00Adobe Fireworks CS5.1\xAB\x1FH\xEB\x00\x00\x03\xBCIDATX\x85\xCD\x98\xE1v\xA2:\x10\x80K\x1Be\x93\xEA\x86\"DV\x90\xE6\x1A\x17w\xD9Z\xA2\xDB\"b]\xDE\xFF\xAD\xEEL\x02\xD6\xDA\xDE{\xF6\x1F\x9D\xA3\x12'\xC9\xF01\x93\x89\x19\xAF\x06\xBD\ne\t\xC8\xD0HUy^\x10hM\x8F\x85\xDF\xB4r\xD5/\x9ERI+\x960\xD0\\\u008B#Q\xC3d\xFF\x19\xF0(\xA3\x84\xEB\xC0\xAB@<`#\x8AqQ\x13%\x04G\xE5\xB0o<\xA5\x14c\xA2\x13J\x15|Y\xC0'\x8B|\xA5(\xED\x19ow\xF3\xCF\xCD\xEEnw\x03\xB2\xBB\xD9\x99\xEB\x82<<,\x8E\xF0:\x1E\x1F\x8E=\xE31\n\xC1\xA5L\xA1\x94%)\n^\bE\xF1\xAA\xE1S\x90\xBES\xC3g\x9EZ*E\n\\k6;8\x11T\x04\xF5\x06\xC9{\xC6\x83\x14\xA8\xA2Z\x91\xED\xFE$\tn1E\xE0\xBAB5\xFB\x9E\xF1\b\xD1\x1Es\xA9\xC8\x9A0\xCB\x90\xAD\xDDb\b\xE0\x91\xA8\xF7\x8DE\x10\xEE\xB1\xBA\xA4Y\xA6\xEB2l\xC20\xDC\x1A\xEF\x11\x0F\xF0\xFCO\x81\xE7\xD7Bd\x99\xBA\xFA\x93U\x84\x90\xE2v_]\xE2\x8Ds-\xE5\x80\xCB\x81\x93\xDAi\xD0|s}'\xA3\xFF\xECy/\x9D\xD1\x0Ff\xD9\xB5'\xC0{\xE5\xFA1\xA3\x87\x97\xC3\xE1\xD9K<\x8B\xD7\x05w\xAE\xB53\x9A!K\x1A\xFF%\x1E\xE7\xA3\xBF\xC6\xEB\x8C~0\xAB\xC5S\x16\xAF|\xF9\x12\xFF^?'\xE0\xBD`Y\x93hoS\xC3\x91N\xCB\x02\xAF\xF9\x84\xCB)\\c\xFD\x84*\xAEg0 \xD6\x0E\xD8\x8ES\xDBB\xBD\xE4\xF3\\s\xF0\x8B\xCC\xF1\x9Er\xC55\xF4\xC1\xD8\x94\xEB|n\xB5\x13\x1D\xCF[\xBB1\xF6\x9D\xCD\x8A-2\x067\xAA\xA9\xF1\xDE\x0F\xF3n\x9E\xD7e\xF2\x16\xAF\xF5\x91\xC5\x9BHg4\xE6\xD2\x913\xA3rx<\x18I\xC7\x91O\\\u00C6#\xDB\x1A\f\xA62\x9EN\xE4,\x85\xE7\x922\x1F\x03\x9E\x9Ei3v&\xD3\x99\xCC\x8D6\x95\xA38\xEF\xECb\xDF\xD9\xACs\xBC\x8D\x10aF\r\xDE\x9Fm\xF8k\xFD\xED\xF6\x7F\xF0xl\x9AzuN\x8C\\\\\u008E\xDB\x16tH\x0E\xDED\xD7\r\xA4\xB9\x11~7cs\x8914\xDA8\x1E\xE5\xFA\xD5\xAE<\x9F\xD5\x05\x97\x14\x80WR\xC4{4x[\xB5\xFEy\xEB\x91 \x02\xBC\xC4\xE2\xC1c\xBE\xB2h\x8B\xC7\x8D\xAE\xB3\f\x92\xA2}\xDB:\xC3[a\xEB\x1D\x9E6Z\x1C+?\xC4[\xBD\xAE\xBD\xC2\xF3\xE1\xF7\xE1\fo\xB9~\x04<}\x867>\xA5\x86\xB1o\x82;\x95\xF1\xC9\xB2#S\xDB\xDD\xB6,N\x8Ea\x9A]\xE29\x18\xDC\x89\xD1\xAE\xC0\xEA\xF4\x12\xAF\x9D\xD5\x05W\x14\x81_+\xD5\xE1\xFD\xC8\xB6\xCFk2D\xBC\rY\xB6x\x83\xA7\x95\x04\x9A65riRc\x82Al\xCD\x82\xE7\xF8\x93Y\x02\xA6eq\xBA\xD4x\x8B\xD7\xA5\x06h\xD1Rz\x89w\x91\x1A\x82\x04g\xDE{\xF9\xF2\xEB\xEB\xE1\xEB\xDE\xF3\b\x87\xB5\xB7L\x92\xBE\xB7e\xF0\x1E3x\f\xB6e\xFA\xFD\xE5\xF0\xFD\xE7p\x18 \xDE\xE6s\xE0iV+\x1A6\x9E\xD0Mu}}\x1D4ph\xA9\x88\xFE\x14xT\x10\xCD6\x8C\x86I\x136\xC3\x04\xAA\x0B<\x11@p\xF5\xB2\x16\xFD\xE3)\xC59\xAC=Qaaa\xCB5,\x87\n\xA2\xDDZ\xF8\x9E\xD73\x9E\xBBP\xB0\xEFQ\xD7\xC7c3\x9C\x91yQ\x10\xCA\"\xD7\x0F\xD0{\x11\xEB\x19o\xF3\xB0 \xFE\x82m\\w\x19\xF9(\x8C1\xDF_\xC2y\x00N\xCB\xB5\xBB\xEC\x19\xEF\xEE\xEE~\xA1\xEEm-\x84U\x11\x94FFv\xBE\x7F\x8F\x95Q\xDFk\xAF\xA4 \xA6\x88\x84b\x88\n\xE3>FOue\xCFxP\x82\x07\x81)\xC19)K\xCE\x16Jp\xED\x99$\xC1s}\xD53\x1Efje\xFF\"\x80\xB4\x80e\xE8\xD3\xED\xBE9I\xDF\xA5\x90\x17\xB4\xC2\x81N\bvdQh\xAB5+\xFF\x02\xA8\xA2\xE17KRuJ\x00\x00\x00\x00IEND\xAEB`\x82"
    var ids = dlg.add('iconbutton', undefined, ico);
        ids.onClick = function(){GotoLink("http://indesignsecrets.com/batch-apply-xmp-alt-tags-to-epub-and-html-images.php/");};
        ids.preferredSize = [162,34];
    
    dlg.center();
    var res = dlg.show();
    
    if(res == true){
        var i, counter = 0;
            for(i = 0; i < lnk.length; i++){
                if(lnk[i].parent.parent.objectExportOptions.altTextSourceType == SourceType.SOURCE_XML_STRUCTURE && overwirte.value != true){
                    lnk[i].parent.parent.objectExportOptions.altTextSourceType = values[source.selection.index];
                    counter++;
                }else if (overwirte.value == true){
                    lnk[i].parent.parent.objectExportOptions.altTextSourceType = values[source.selection.index];
                    counter++;
                }
            }
        if(counter > 0)
            alert("Done!\r\rNumber of Processed Images: " + counter, appName);
        else
            alert("No Images affected!", appName);
    }
}

function GotoLink(url){
    url = url || "http://tomaxxi.com";
    if(File.fs=="Macintosh"){
        var body = 'tell application "Finder"\ropen location "'+url+'"\rend tell';
        app.doScript(body,ScriptLanguage.APPLESCRIPT_LANGUAGE);
    } else {
        var body =  'dim objShell\rset objShell = CreateObject("Shell.Application")\rstr = "'+url+'"\robjShell.ShellExecute str, "", "", "open", 1 '
        app.doScript(body,ScriptLanguage.VISUAL_BASIC);
    }
}